{--------------------------------------------------------}
{                                                        }
{    Programa acesso simplificado ao Google              }
{                                                        }
{    Mdulo de leitura interativa                        }
{                                                        }
{    Autor: Jos Antonio Borges e Fabiano Ferreira       }
{                                                        }
{    Em maio/2013                                        }
{                                                        }
{--------------------------------------------------------}

program googlevox;
uses
  windows,
  shellapi,
  dvcrt,
  dvwin,
  dvinet,
  dvForm,
  dvssl,
  dvexec,
  SysUtils,
  classes,
  superobject,
  gvhtml,
  gvmsg;


const
    versao = '1.0';

var
    resultado: TStringList;
    sock: integer;

{--------------------------------------------------------}
{        limpa debaixo de certa posio da tela          }
{--------------------------------------------------------}

procedure limpaBaixo (y: integer);
var i: integer;
begin
    for i := y to 25 do
        begin
            gotoxy (1, i);
            clreol;
        end;
    gotoxy (1, y);
end;

{--------------------------------------------------------}
{                     codifica URL                       }
{--------------------------------------------------------}

function UrlEncode2(s: String): String;
var i: Integer;
begin
    Result := '';
    for i := 1 to length(s) do
        begin
            if s[i] in ['0'..'9', 'a'..'z', 'A'..'Z', '.', '-', '_', '~'] then
                Result := Result + s[i]
            else
                Result := Result + '%' + IntToHex(Ord(s[i]), 2);
        end;
end;

{--------------------------------------------------------}
{        faz uma pesquisa pela antiga Google API         }
{--------------------------------------------------------}

function trazDoGoogle (busca: string; inicio: integer): string;
var
    s, pad: string;
    pbuf: PbufRede;
    ok, achou: boolean;
    c: char;

begin
    sock := abreConexao ('www.google.com', 80);
    busca := UrlEncode2(UTF8Encode(busca));

    writelnRede (sock, 'GET /uds/GwebSearch?callback=response&rsz=large&v=1.0&start=' +
                        intToStr(inicio) + '&hl=pt-BR&q=' + busca + ' HTTP/1.0');
    writelnRede (sock, 'Host: www.google.com');
    writelnRede (sock, 'User-Agent: GoogleVox v1.0');
    writelnRede (sock, 'Accept-Language: pt-br');
    writelnRede (sock, 'UA-CPU: x86');
    writelnRede (sock, '');

    pbuf := inicBufRede (sock);
    repeat
        ok := readlnBufRede(pbuf, s, 5000);
    until (not ok) or (s = '');

    pad := '';
    achou := false;
    repeat
        ok := leCaracBufRede(pbuf, c);
        if ok then
                if c = '(' then
                    achou := true
                else
                    pad := pad + c;
    until achou or (not ok);

    s := '';

    if ok and achou then
        repeat
            while not temDadoBufRede(pbuf) do delay (100);
            ok := leCaracBufRede(pbuf, c);
            if ok then s := s + c;
        until not ok;

    fimBufRede (pbuf);
    fechaConexao(sock);

    // resposta vem em JSon-P, remove nome e parnteses
    while (s <> '') and (s[length(s)] <> ')') do
        delete (s, length(s), 1);
    delete (s, length(s), 1);

    result := s;
    if pos ('{"responseData": null', s) = 1 then    // google no permitiu
        begin
            mensagem ('GVRECUSA', 1);  {'A google recusou seu pedido.'}
            result := '';
        end;
end;

{--------------------------------------------------------}
{                      faz uma busca                     }
{--------------------------------------------------------}

procedure buscaNoGoogle (busca: string; nivelDeBusca: integer);
var
    nn : integer;
    s : string;
    w : widestring;
    lidos_antes: integer;
    i: integer;

    lido, obj: ISuperObject;
    lista: TSuperArray;
    numRegLidos: integer;

Begin
    lidos_antes := 0;
    lista := NIL;
    for nn := 0 to nivelDeBusca-1 do
        begin
            s:= trazDoGoogle (busca, lidos_antes);

            if s = '' then
                numRegLidos := 0
            else
                begin
                    w := s;
                    lido := TSuperObject.ParseString2(pWideChar(w));
                    lista := lido['responseData']['results'].AsArray;
                    numRegLidos := lista.length;
                end;

            for i := 0 to numRegLidos - 1 do
                begin
                    obj := lista.O[i];

                    resultado.add (removeTagsHTML(Utf8ToAnsi(obj['title'].AsString)));
                    resultado.add (removeTagsHTML(Utf8ToAnsi(obj['content'].AsString)));
                    resultado.add (obj['url'].AsString);
                end;

            lidos_antes := lidos_antes + numRegLidos;
            sintbip;
            if numRegLidos < 8 then break;
        end;
end;

{--------------------------------------------------------}
{                       termina                          }
{--------------------------------------------------------}

procedure termina;
begin
    mensagem ('GVTCHAU', 1);  {'At a prxima, pessoal!'}
    sintFim;
    fechaWinsock;
    halt;
end;

{--------------------------------------------------------}
{                     inicializao                      }
{--------------------------------------------------------}

procedure inicializa;
var ambiente: string;
begin
    setwindowtitle('GoogleVox');
    ambiente := sintAmbiente ('GOOGLEVOX', 'GOOGLEVOXDIR');
    if ambiente = '' then
        ambiente := 'c:\winvox\som\googlevox';
    sintinic (0, ambiente);

    textBackground (BLUE);
    mensagem ('GVINIC', 0);  {'Acesso rpido ao Google - v.' + versao'}
    sintWriteln (versao);
    textBackground (BLACK);
    mensagem ('GVLIMIT', 1);  {'Limitado a 100 pesquisas por dia.'}
    writeln;

    if not abreWinsock then
        begin
            mensagem ('GVNLIG', 1);  {'Seu computador no est ligado  Internet'}
            termina;
        end;
end;

{--------------------------------------------------------}
{            Descobre qual  o navegador padro          }
{--------------------------------------------------------}

function GetDefaultBrowser: string;
var
    tmp : PChar;
    res : PChar;
begin
    tmp := StrAlloc(255);
    res := StrAlloc(255);
    try
        GetTempPath(255,tmp);
        FileCreate(tmp+'htmpl.htm');
        FindExecutable('htmpl.htm',tmp,Res);
        Result := ExtractFilePath(res) + ExtractFileName(res);
        SysUtils.DeleteFile(tmp+'htmpl.htm');
    finally
        StrDispose(tmp);
        StrDispose(res);
    end;
end;

{--------------------------------------------------------}
{       mostra o youtube no navegador web padro         }
{--------------------------------------------------------}

procedure mostraWeb (pagina: string);
begin
    mensagem ('GVABRNAV', 1);  {'Abrindo navegador. Acione ALT F4 quando terminar.'}
    while sintFalando do waitMessage;
    delay (100);

    executaProg(GetDefaultBrowser, '', pagina);
    delay (5000);
    while getForegroundWindow <> crtWindow do delay (500);
end;

{--------------------------------------------------------}
{                     chama o navegador                  }
{--------------------------------------------------------}

procedure chamaNavegador (site: string);
var nomeProg: string;
begin
    nomeProg := sintAmbiente ('GOOGLEVOX', 'NAVEGADOR');
    if nomeProg = '' then
        nomeProg := 'c:\winvox\webvox.exe';

    if executaProg (nomeProg, '', site) >= 32 then
        begin
            esperaProgVoltar;
            while sintFalando do waitMessage;
        end
    else
        mensagem ('GVERRNAV', 1);  {'Erro ao chamar o navegador'}
end;

{--------------------------------------------------------}
{            Interao sobre os sites achados            }
{--------------------------------------------------------}

procedure selecionaDaBusca (busca: string);
var i: integer;
    nselec: integer;
    link: string;
    s, s2: string;
    c: char;
begin
    repeat
        clrscr;
        textBackground (BLUE);
        writeln (PegaTextoMensagem ('GVINIC'));   {'Acesso rpido ao Google - v.' + versao}
        textBackground (BLACK);
        writeln (busca);

        textBackground (RED);
        mensagem ('GVSELSIT', 1);  {'Selecione o site desejado e tecle enter'}
        textBackground (BLACK);

        opcoesCria(wherex, wherey, 80);
        i := 0;
        nselec := 1;
        while i < resultado.count do
            begin
                opcoesAdiciona('', resultado[i]);
                inc (i, 3);
            end;

        nselec := opcoesSelecInic(nselec);
        if nselec = 0 then break;

        link := resultado[nselec*3-1];
        writeln (resultado[nselec*3-3]);
        writeln (link);
        limpaBaixo (3);

        writeln;
        textBackground (RED);
        mensagem ('GVTXTINI', 1);  {'Texto inicial da pgina:'}
        textBackground (BLACK);

        s := resultado[nselec*3-2];
        while s <> '' do
            begin
                s2 := copy (s, 1, 80);
                while (s2 <> '') and (s2[length(s2)] <> ' ') do
                    delete (s2, length(s2), 1);
                if s2 = '' then
                    s2 := copy (s, 1, 80);
                delete (s, 1, length(s2));
                s := trim (s);

                writeln (s2);
            end;
        sintetiza (resultado[nselec*3-2]);

        sintBip;

        writeln;
        textBackground (RED);
        mensagem ('GVAPENTW', 1);  {'Aperte ENTER para chamar o Webvox,'}
        mensagem ('GVCTLENT', 1);  {'       Control-ENTER para navegador,'}
        mensagem ('GVESCIGN', 1);  {'       ESC para ignorar.'}
        textBackground (BLACK);

        c := readkey;
        case c of
           CTLENTER: mostraWeb (link);
           ENTER:    chamaNavegador(link);
        else
           mensagem ('GVDESIST', 1);    {'Desistiu...'}
        end;
    until c = ESC;
end;

{--------------------------------------------------------}
{                   processa um pedido                   }
{--------------------------------------------------------}

procedure processa;
var
    busca: string;
    nivelBusca: integer;
    c: char;
begin
    textBackground (BLUE);
    mensagem ('GVOQUE', 1);  {'Google - o que voc deseja buscar? '}
    textBackground (BLACK);
    sintReadln (busca);
    if busca = '' then exit;

    mensagem ('GVBUSBRA', 0); {'Busco s no Brasil? '}
    c := sintReadkey;
    if c = ESC then
        begin
            mensagem ('GVDESIST', 1);  {'Desistiu'}
            exit;
        end;
    writeln (c);
    if (upcase(c) = 'S') then busca := 'site:br ' + busca;

    mensagem ('GVNIVEL', 0); {'Nvel da pesquisa, de 1 a 4? '}
    sintReadint (nivelBusca);
    if nivelBusca < 1 then
        begin
            mensagem ('GVDESIST', 1);  {'Desistiu'}
            exit;
        end;
    if nivelBusca > 4 then nivelBusca := 4;

    resultado := TStringList.Create;
    buscaNoGoogle (busca, nivelBusca);
    if resultado.count <> 0 then
        selecionaDaBusca (busca)
    else
        mensagem ('GVNAOACH', 1);  {'No consegui achar o que voc procurava.'}
    resultado.free;
end;

{--------------------------------------------------------}
{                   programa principal                   }
{--------------------------------------------------------}

var c: char;
begin
    inicializa;
    repeat
        processa;

        limpabaixo (2);
        textBackground (RED);
        mensagem ('GVMAISB', 0); {'Mais buscas (s/n)? '}
        textBackground (BLACK);
        c := sintReadkey;
        writeln (c);
        limpaBufTec;
    until upcase (c) <> 'S';

    termina;
end.

